import random
import unicodedata


class DjangoHeaderMiddleware:
    def __init__(self, get_response):
        self.get_response = get_response

    def __call__(self, request):
        response = self.get_response(request)
        # Including accents in HTTP headers may not work, so we strip them:
        response["Django-Composition"] = remove_diacritics(random.choice(COMPOSITIONS))
        return response


def remove_diacritics(text):
    return "".join(
        c
        for c in unicodedata.normalize("NFKD", text)
        if unicodedata.category(c) != "Mn"
    )


COMPOSITIONS = [
    "Anouman",
    "Appel Indirect",
    "Are you in the Mood",
    "Artillerie Lourde",
    "Babik",
    "Belleville",
    "Black and White",
    "Black Night",
    "Diminishing",
    "Diminishing Blackness",
    "Blues",
    "Blues Clair",
    "Blues d'Autrefois",
    "Blues en Mineur",
    "Blues for Barclay",
    "Blues for Ike",
    "Blues Riff",
    "Boléro",
    "Boogie Woogie",
    "Bricktop",
    "Cavalerie",
    "Chez Jacquet",
    "Choti",
    "Christmas Swing",
    "Crépuscule",
    "D.R.Blues",
    "Daphné",
    "Del Salle",
    "Deccaphonie",
    "Dinette",
    "Djalamichto",
    "Djangology",
    "Django Rag",
    "Django's Blues",
    "Django's Tiger",
    "Double Whisky",
    "Douce Ambiance",
    "Duke and Dukie",
    "Echoes of Spain",
    "En Verdine",
    "Fantaisie",
    "Fat",
    "Féerie",
    "Festival 48",
    "Fiddle Blues",
    "Fleche d'Or",
    "Fleur d'Ennui",
    "Folie à Amphion",
    "Gagoug",
    "Gaiement",
    "Gin Gin",
    "Gypsy with a Song Pt1 & Pt2",
    "HCQ Strut",
    "Hungaria",
    "Impromptu",
    "Improvisation #1",
    "Improvisation #2",
    "Improvisation #3",
    "Improvisation #4",
    "Improvisation #5",
    "Improvisation #6",
    "Incidental Music for Racine's Andromaque",
    "Just For Fun",
    "Lentement Madamoiselle",
    "Mabel",
    "Mano",
    "Manoir de mes rêves",
    "Django's Castle",
    "Castle of My Dreams",
    "Mélodie au crépuscule",
    "Love's melody",
    "Messe des Saintes-Maries-de-la-Mer",
    "Micro",
    "Mike",
    "Swing Dynamique",
    "Minor Blues",
    "Minor Swing",
    "Moppin' The Bride",
    "Danse nuptiale",
    "No Name Blues",
    "Montagne Sainte-Genevieve",
    "My Serenade",
    "Mystery Pacific",
    "Naguine",
    "Nocturne",
    "Nuages",
    "Nuits de Saint-Germain-des-Prés",
    "Nymphéas",
    "Oiseaux des iles",
    "Oriental Shuffle",
    "Oubli",
    "Paramount Stomp",
    "Parfum",
    "Pêche à la Mouche",
    "Place de Brouckère",
    "Porto Cabello",
    "Pour que Ma Vie Demeure",
    "R. vingt-six",
    "Rhythme Futur",
    "Souvenirs",
    "Spivy",
    "Speevy",
    "Stephen's Blues",
    "Stockholm",
    "Stompin' at Decca",
    "Sweet Chorus",
    "Swing 39",
    "Swing 41",
    "Swing 42",
    "Swing 48",
    "Swing de Paris",
    "Swing From Paris",
    "Swing Guitars",
    "Swinging With Django",
    "Swingtime in Springtime",
    "Tears",
    "Testament",
    "This Kind of Friend",
    "Troublant Boléro",
    "Twelfth Year",
    "Two Improvised Guitar Choruses",
    "Ultrafox",
    "Vamp",
    "Vendredi 13",
    "Vette",
    "Webster",
]
